#include <Python.h>
#include <ft2build.h>
#include FT_FREETYPE_H
#include <freetype/ftglyph.h>

typedef struct {
	PyObject_HEAD
	FT_Library library;
} Library;

typedef struct {
	PyObject_HEAD
	FT_Face face;
	Library * reflib;
} Face;

typedef struct {
	PyObject_HEAD
	FT_Glyph glyph;
	Face    * refface;
} Glyph;

typedef struct {
	PyTypeObject * LibraryType;
	PyTypeObject * FaceType;
	PyTypeObject * GlyphType;
} pyft2_C_api;

#ifdef PYFT2_MODULE

extern PyTypeObject LibraryType;
extern PyTypeObject FaceType;
extern PyTypeObject GlyphType;


#define LibraryCheck(op) ((op)->ob_type == &LibraryType)
#define FaceCheck(op)    ((op)->ob_type == &FaceType)
#define GlyphCheck(op)   ((op)->ob_type == &GlyphType)

#else

extern pyft2_C_api * ft2_c_api;

#define LibraryCheck(op) ((op)->ob_type == ft2_c_api->LibraryType)
#define FaceCheck(op)    ((op)->ob_type == ft2_c_api->FaceType)
#define GlyphCheck(op)   ((op)->ob_type == ft2_c_api->GlyphType)

#endif

#define ASSERT_FACE(o,r) do { if(!FaceCheck(o)) { \
	       PyErr_SetString(PyExc_TypeError,"Face expected"); \
	       return r; } } while(0)
